      IMPLICIT REAL*8(A - H,O - Z)
      DIMENSION CD(31),CI(31),CF(31)
      CHARACTER*12 TABNOM
      RAD = DACOS(-1.0D0) / 180.0D0
      OPEN (1,FILE='COEF-D95',STATUS='OLD')
      READ (1,*,END=20) (CD(I),I=1,31)
   20 CLOSE (1)
      OPEN (2,FILE='COEF-I95',STATUS='OLD')
      READ (2,*,END=21) (CI(I),I=1,31)
   21 CLOSE (2)
      OPEN (3,FILE='COEF-F95',STATUS='OLD')
      READ (3,*,END=22) (CF(I),I=1,31)
   22 CLOSE (3)
C*    ----------------------------------------------------------------- 
   30 CALL CLS
      WRITE (*,*)'                                                  '
      WRITE (*,*)'       Elementos do Campo Geomagneticos no Brasil '
      WRITE (*,*)'                                                  '
      WRITE (*,*)'                                                  '
      WRITE (*,*)'                                                  '
      WRITE (*,*)'       Entre com a    Data    Latitude   Longitude'
      WRITE (*,*)'                                                  '   
      WRITE (*,*)'             Ex.:   1998.453  -15.294     -66.985 '
      WRITE (*,*)'                                                  '
      WRITE (*,*)'                '
      READ  (*,*) EPOCA, ALAT, ALON 
      XLAT = ALAT + 15.0D0                                           
      XLON = ALON + 55.0D0
      EPOC = EPOCA - 1990.0D0
C     -----------------------------------------------------------------
      CALL ELEMEN(XLAT,XLON,CD,EPOC,ELED)
      CALL ELEMEN(XLAT,XLON,CI,EPOC,ELEI)
      CALL ELEMEN(XLAT,XLON,CF,EPOC,ELEF)
C     -----------------------------------------------------------------
      CALL VARIAC(XLAT,XLON,CD,EPOC,VD)
      CALL VARIAC(XLAT,XLON,CI,EPOC,VI)
      CALL VARIAC(XLAT,XLON,CF,EPOC,VF)
      VD = VD * 60.0D0
      VI = VI * 60.0D0
C     -----------------------------------------------------------------
      H = ELEF*DCOS(RAD*ELEI)
      Z = ELEF*DSIN(RAD*ELEI)
      X = H * DCOS(RAD*ELED)
      Y = H * DSIN(RAD*ELED)
      F = ELEF
      D = ELED
      AI= ELEI
C    ------------------------------------------------------------------
      VH = VF * DCOS(RAD*ELEI)   - ELEF * VI * DSIN(RAD*ELEI)/3600.0D0 
      VZ = VF * DSIN(RAD*ELEI)   + ELEF * VI * DCOS(RAD*ELEI)/3600.0D0
      VX = VH   * DCOS(RAD*ELED) - H * VD * DSIN(RAD*ELED)/3600.0D0
      VY = VH   * DSIN(RAD*ELED) + H * VD * DCOS(RAD*ELED)/3600.0D0
C     -----------------------------------------------------------------
      IDC = ELED
      DMIN = ABS((D - IDC)) * 60.D0
      INC = ELEI
      AIMIN = ABS((AI - INC)) * 60.D0
      CALL CLS
      WRITE(6,*)'         ______________________________________ '
      WRITE(6,*)'        I                                      I'
      WRITE(6,*)'        I   CNPq - Observatorio Nacional       I'
      WRITE(6,*)'        I   Departamento de Geofisica          I'
      WRITE(6,*)'        I   Versao 1.1    1985, 1990, 1995     I'
      WRITE(6,*)'        I______________________________________I'
      WRITE(6,*)'                                                '
      WRITE(6,*)'                                                '
      WRITE (6,50)EPOCA,ALAT,ALON, X, VX, Y, VY, Z, VZ, H, VH, F, VF, 
     1IDC, DMIN, VD, INC, AIMIN, VI
   50 FORMAT (10X, 'Epoca     ', F9.3, /,
     *       10X, 'Latitude  ', F9.3,  /, 
     1       10X, 'Longitude   ', F7.3, 22X, 'Variacao ', //, 10X, 
     2       'Componente [ X ]   ',F12.0, 3X, F9.1,10H  nT / ano,/10X, 
     3       '    "      [ Y ]   ',F12.0, 3X, F9.1,10H  nT / ano,/ 10X, 
     4       '    "      [ Z ]   ',F12.0, 3X, F9.1,10H  nT / ano,/ 10X, 
     5       '    "      [ H ]   ',F12.0, 3X, F9.1,10H  nT / ano,/ 10X, 
     6       '    "      [ F ]   ',F12.0, 3X, F9.1,10H  nT / ano,/ 10X, 
     7       '    "      [ D ] ',4X,I5,F6.1,3X,F8.1,10H   ' / ano,/10X, 
     8       '    "      [ I ] ',4X,I5,F6.1,1X,F10.1,10H   ' / ano)
C     -----------------------------------------------------------------
      WRITE (*,*)'                   '
      WRITE (*,*)'                Quer gravar a tabela acima ..... 1  '
      WRITE (*,*)'                               nova tabela ..... 2  '
      WRITE (*,*)'                                   termina ..... 0  '
      WRITE (*,*)'                                                    '
      READ  (*,*)IGRAV
      IF(IGRAV.EQ.0) GO TO 70
      IF(IGRAV.EQ.2) GO TO 30
      WRITE(*,*)'                 Entre nome do Arquivo saida'
      WRITE (*,*)'                                                    '
      WRITE (*,*)'                   '
      READ  (*,'(A12)') TABNOM
      OPEN (1,FILE=TABNOM )
      WRITE (1,'(//)')
      WRITE (1,50) EPOCA,ALAT,ALON, X, VX, Y, VY, Z, VZ, H, VH, F, VF, 
     1IDC, DMIN, VD, INC, AIMIN, VI
      WRITE (*,*)'                   '
      WRITE (*,*)'                   '
      WRITE (*,*)'                         Quer nova tabela  ..... 1  '
      WRITE (*,*)'                                  termina  ..... 0  '
      WRITE (*,*)'                                                    '
      READ  (*,*) ITAB
      IF (ITAB .EQ. 0 ) GO TO 70
      GO TO 30
   70 STOP 
      END 
C* 
      SUBROUTINE CLS
      DO 10 K=1,15
   10 WRITE(*,15)
   15 FORMAT(1H0)
      RETURN
      END
C*
C*    ----------------------------------------------------------------- 
C*    INICIO DA SUBROTINA POLINOMIAL 
C*    ----------------------------------------------------------------- 
      SUBROUTINE ELEMEN(Y,X,C,T,RES)
C
C     ELEMEN e' um polinomio do quarto grau --> P{ Y,X,T }**4 
C     Variavel [ Y ] representa a latitude  reduzida (ver linha 27)    
C     Variavel [ X ] representa a longitude reduzida (ver linha 28)    
C     Variavel [ T ] representa a epoca     reduzida (ver linha 29)    
C
      IMPLICIT REAL*8(A - H,O - Z)
      DIMENSION C(30)
      P1=C(1)+C(2)*Y+C(3)*X+C(4)*T+C(5)*X*X+C(6)*X*Y+C(7)*X*T+C(8)*Y*Y
      P2=C(9)*Y*T+C(10)*T*T+C(11)*X*X*X+C(12)*X*X*Y+C(13)*X*X*T
      P3=C(14)*X*Y*Y+C(15)*X*Y*T+C(16)*X*T*T+C(17)*Y*Y*Y+C(18)*Y*Y*T
      P4=C(19)*Y*T*T+C(20)*X*X*X*X+C(21)*X*X*X*Y+C(22)*X*X*X*T
      P5=C(23)*X*X*Y*Y+C(24)*X*X*Y*T+C(25)*X*X*T*T+C(26)*X*Y*Y*Y
      P6=C(27)*X*Y*Y*T+c(28)*Y*Y*Y*T+C(29)*X*Y*T*T
      p7=C(30)*Y*Y*Y*Y+C(31)*Y*Y*T*T
      RES = P1 + P2 + P3 + P4 + P5 + P6 +P7
      RETURN 
      END 
C
      SUBROUTINE VARIAC(Y,X,C,T,VAR)
C
C     VARIAC e' derivada temporal do Polinomio na subrotina ELEMEN
C     Variavel [ Y ] representa a latitude  reduzida (ver linha 27)    
C     Variavel [ X ] representa a longitude reduzida (ver linha 28)    
C     Variavel [ T ] representa a epoca     reduzida (ver linha 29)    
C
      IMPLICIT REAL*8(A - H,O - Z)
      DIMENSION C(35)
      DATA P,Q,R/2.0D0,3.0D0,4.0D0/
      P1=C(4)+C(7)*X
      P2=C(9)*Y+2.*C(10)*T+C(13)*X*X
      P3=C(15)*X*Y+2.*C(16)*X*T+C(18)*Y*Y
      P4=2.*C(19)*Y*T+C(22)*X*X*X
      P5=C(24)*X*X*Y+2.*C(25)*X*X*T
      P6=C(27)*X*Y*Y+C(28)*Y*Y*Y+2.*C(29)*X*Y*T+2.*C(31)*Y*Y*T
      VAR = P1 + P2 + P3 + P4 + P5 + P6 
      RETURN 
      END
